<script lang="ts">
	export let name: string | null = null
	export let nameError: string = ""
	export let description: string | null = null
	export let filteredFiles: Array<string> = []
	export let selectedProject: Project | null = null
	export let editDataPackage: boolean = false
	export let errorMessage: string | null = null
	export let previousDataPackage: DataPackage | null = null

	// used only on "Edit" mode
	export let previousFiles: Array<string> | null = null
	export let removedFiles: Array<string> | null = null

	let uploadedFiles: Array<string> = []

	import { createEventDispatcher } from "svelte"
	import type { DataPackage, Project } from "$lib/storage"
	import BackendSelect from "./BackendSelect.svelte"
	import FileInput from "./FileInput.svelte"

	const dispatch = createEventDispatcher<{ submit: FormData }>()

	function updateName(event) {
		name = event.target.value
		if (name.length === 0) {
			name = null
		}
		nameError = ""
	}

	function updateDescription(event) {
		description = event.target.value
		if (description.length === 0) {
			description = null
		}
	}

	function handleSubmit(event) {
		const formData = new FormData(event.target)
		dispatch("submit", formData)
	}

	let submitDisabled = true
	$: submitDisabled = !(name !== null && filteredFiles.length > 0)

	$: if (editDataPackage && name && description && uploadedFiles) {
		const filesChanged = uploadedFiles.length > 0 || removedFiles.length > 0
		const dataPackageChanged =
			previousDataPackage.name !== name || previousDataPackage.description !== description || filesChanged
		submitDisabled = !(name !== null && filteredFiles.length > 0 && dataPackageChanged)
	}
</script>

{#if errorMessage}
	<div class="alert text-red-700 bg-red-100" role="alert">{errorMessage}</div>
{/if}

<form class="w-full md:w-4/12 py-10 space-y-4 mb-8" on:submit|preventDefault={handleSubmit}>
	<div class="card">
		<div class="card-header">Name *</div>
		<div class="card-body">
			<label class="form-input" for="datapackage-name">
				<input type="text" class="w-full" name="datapackage-name" required value={name} on:input={updateName} />
			</label>
			{#if nameError}
				<div class="px-4 mt-4 text-red-500" name="datapackage-name-error">{nameError}</div>
			{/if}
		</div>
	</div>

	<div class="card">
		<div class="card-header">Description</div>
		<div class="card-body">
			<label class="form-input" for="datapackage-description">
				<input
					type="text"
					class="w-full"
					name="datapackage-description"
					value={description}
					on:input={updateDescription}
				/>
			</label>
		</div>
	</div>

	<div class="card">
		<div class="card-header">Resources *</div>
		<div class="card-body">
			<FileInput bind:filteredFiles {previousFiles} bind:removedFiles bind:uploadedFiles />
		</div>
	</div>

	{#if !editDataPackage}
		<div class="card">
			<div class="card-header">Store Data Package on *</div>
			<div class="card-body space-y-4">
				<BackendSelect />
				<slot />
			</div>
		</div>
	{/if}
	<input
		type="submit"
		disabled={submitDisabled}
		class="btn btn-primary w-64 mt-4 float-right"
		value={`${editDataPackage ? "Update" : "Create"} Data Package`}
	/>
</form>

<style>
	input {
		outline: none;
	}
</style>
